
/* Zaneme potebnmi hlavikami a po nich napeme definici funkce printdir,
   kter vype aktuln adres. Pro podadrese ji budeme volat rekurzivn - 
   budeme do n pedvat parametr hloubky vnoen depth, kter definuje tak odsazen. */

#include <unistd.h>
#include <stdio.h>
#include <dirent.h>
#include <string.h>
#include <sys/stat.h>
#include <stdlib.h>

void printdir(char *dir, int depth)
{
    DIR *dp;
    struct dirent *entry;
    struct stat statbuf;

    if((dp = opendir(dir)) == NULL) {
        fprintf(stderr,"nemohu otevt adres: %s\n", dir);
        return;
    }

    chdir(dir);
    while((entry = readdir(dp)) != NULL) {
        lstat(entry->d_name,&statbuf);
        if(S_ISDIR(statbuf.st_mode)) {
            /* Adres nalezen; poloky . a .. ignorujeme */
            if(strcmp(".",entry->d_name) == 0 ||
                strcmp("..",entry->d_name) == 0)
                continue;
            printf("%*s%s/\n",depth,"",entry->d_name);
            /* Rekurzivn voln s novou rovn odsazen */
            printdir(entry->d_name,depth+4);
        }
        else 
            printf("%*s%s\n",depth,"",entry->d_name);
    }
    chdir("..");
    closedir(dp);
}

/* Te pejdeme k deklaraci funkce main: */

int main(int argc, char* argv[])
{
    char *topdir = ".";
    if (argc >= 2)
        topdir=argv[1];

    printf("Prochzen adrese %s\n",topdir);
    printdir(topdir,0);
    printf("hotovo.\n");

    exit(0);
}
