// Ze veho nejdve si ovme, jestli dan terminl podporuje barvy; pokud ano, provedeme inicializaci barev:
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <curses.h>

int main()
{
    int i;

    initscr();

    if (!has_colors()) {
        endwin();
        fprintf(stderr, "Chyba - terminl nepodporuje barvy.\n");
        exit(1);
    }

    if (start_color() != OK) {
        endwin();
        fprintf(stderr, "Chyba - nelze inicializovat barvy.\n");
        exit(2);
    }
// Nyn meme vypsat povolen poet barev a dvojic barev. Dle vytvome sedm
// dvojic barev a postupn v nich zobrazme urit text:
    clear();
    mvprintw(5, 5, "Mme k dispozici %d BAREV, a %d DVOJIC_BAREV",
            COLORS, COLOR_PAIRS);
    refresh();

    init_pair(1, COLOR_RED, COLOR_BLACK);
    init_pair(2, COLOR_RED, COLOR_GREEN);
    init_pair(3, COLOR_GREEN, COLOR_RED);
    init_pair(4, COLOR_YELLOW, COLOR_BLUE);
    init_pair(5, COLOR_BLACK, COLOR_WHITE);
    init_pair(6, COLOR_MAGENTA, COLOR_BLUE);
    init_pair(7, COLOR_CYAN, COLOR_WHITE);

    for (i = 1; i <= 7; i++) {
        attroff(A_BOLD);
        attrset(COLOR_PAIR(i));
        mvprintw(5 + i, 5, "Dvojice barev %d", i);
        attrset(COLOR_PAIR(i) | A_BOLD);
        mvprintw(5 + i, 25, "Dvojice vraznch barev %d", i);
        refresh();
        sleep(1);
    }

    endwin();
    exit(EXIT_SUCCESS);
}

