/* 
 Jako prvn napeme definici datov struktury pro databzi CD. Definujeme zde struktury 
 a velikosti dvou tabulek, z nich je cel databze sloena. pln na zatku nadefinujeme 
 tedy velikosti pol a dv struktury - jednu pro poloku katalogu, jednu pro poloku stopy CD:
*/

/* Tabulka katalogu */
#define CAT_CAT_LEN 30
#define CAT_TITLE_LEN 70
#define CAT_TYPE_LEN 30
#define CAT_ARTIST_LEN 70

typedef struct {
    char catalog[CAT_CAT_LEN + 1];
    char title[CAT_TITLE_LEN + 1];
    char type[CAT_TYPE_LEN + 1];
    char artist[CAT_ARTIST_LEN + 1];
} cdc_entry;

/* Tabulka stop, jedna poloka na jednu stopu */
#define TRACK_CAT_LEN CAT_CAT_LEN
#define TRACK_TTEXT_LEN 70

typedef struct {
    char catalog[TRACK_CAT_LEN + 1];
    int track_no;
    char track_txt[TRACK_TTEXT_LEN + 1];
} cdt_entry;

/* 
 Datov struktury jsou tedy hotovy a my se meme pustit do definice potebnch
 pstupovch rutin. Funkce zanajc na cdc_ pracuj s polokami katalogu,
 funkce na cdt_ s polokami stop:
 Vimnte si, e nkter z funkc vracej datov struktury. 
 Selhn takovchto funkc meme indikovat zpisem przdnho obsahu struktury.
*/

/* Funkce pro inicializaci a ukonen */
int database_initialize(const int new_database);
void database_close(void);

/* Dv funkce pro jednoduch natn dat */
cdc_entry get_cdc_entry(const char *cd_catalog_ptr);
cdt_entry get_cdt_entry(const char *cd_catalog_ptr, const int track_no);

/* Dv funkce pro pidvn dat */
int add_cdc_entry(const cdc_entry entry_to_add);
int add_cdt_entry(const cdt_entry entry_to_add);

/* Dv funkce pro odstraovn dat */
int del_cdc_entry(const char *cd_catalog_ptr);
int del_cdt_entry(const char *cd_catalog_ptr, const int track_no);

/* Jedna funkce pro vyhledvn */
cdc_entry search_cdc_entry(const char *cd_catalog_ptr, int *first_call_ptr);

