#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>

const char *test_file = "/tmp/test_lock";
#define SIZE_TO_TRY 5

void show_lock_info(struct flock *to_show);

int main()
{
    int file_desc;
    int res;
    struct flock region_to_test;
    int start_byte;
// Oteveme souborov deskriptor:

    file_desc = open(test_file, O_RDWR | O_CREAT, 0666);
    if (!file_desc) {
        fprintf(stderr, "Nemohu otevt %s pro ten/zpis", test_file);
        exit(EXIT_FAILURE);
    }

    for (start_byte = 0; start_byte < 99; start_byte += SIZE_TO_TRY) {
// Nyn vytvome oblast, kterou budeme testovat:
        region_to_test.l_type = F_WRLCK;
        region_to_test.l_whence = SEEK_SET;
        region_to_test.l_start = start_byte;
        region_to_test.l_len = SIZE_TO_TRY;
        region_to_test.l_pid = -1;

        printf("Testuji F_WRLCK na oblasti od %d do %d\n",
                start_byte, start_byte + SIZE_TO_TRY);
// A zde zmky v souboru konen otestujeme:
        res = fcntl(file_desc, F_GETLK, &region_to_test);
        if (res == -1) {
            fprintf(stderr, "F_GETLK selhalo\n");
            exit(EXIT_FAILURE);
        }
        if (region_to_test.l_pid != -1) {
            printf("Zmek by selhal. F_GETLK vrtilo:\n");
            show_lock_info(&region_to_test);
        }
        else {
            printf("F_WRLCK - Zmek by byl pidlen spn\n");
        }
// Pot test opakujeme jet jednou, ale tentokrt se sdlenm zmkem (pro ten). Znovu vytvome testovanou oblast:
        region_to_test.l_type = F_RDLCK;
        region_to_test.l_whence = SEEK_SET;
        region_to_test.l_start = start_byte;
        region_to_test.l_len = SIZE_TO_TRY;
        region_to_test.l_pid = -1;
        printf("Testuji F_RDLCK na oblasti od %d do %d\n",
                start_byte, start_byte + SIZE_TO_TRY);
// A pot jet jednou otestujeme zmky v souboru:
        res = fcntl(file_desc, F_GETLK, &region_to_test);
        if (res == -1) {
            fprintf(stderr, "F_GETLK selhalo\n");
            exit(EXIT_FAILURE);
        }
        if (region_to_test.l_pid != -1) {
            printf("Zmek by selhal. F_GETLK vrtilo:\n");
            show_lock_info(&region_to_test);
        }
        else {
            printf("F_RDLCK - Zmek by byl pidlen spn\n");
        }
    }
    close(file_desc);
    exit(EXIT_SUCCESS);
}

void show_lock_info(struct flock *to_show) {
    printf("\tl_type %d, ", to_show->l_type);
    printf("l_whence %d, ", to_show->l_whence);
    printf("l_start %d, ", (int)to_show->l_start);
    printf("l_len %d, ", (int)to_show->l_len);
    printf("l_pid %d\n", to_show->l_pid);
}

