// Po obvyklch direktivch #include a deklaracch nsleduje oteven souborovho deskriptoru:
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>

const char *test_file = "/tmp/test_lock";

int main()
{
    int file_desc;
    struct flock region_to_lock;
    int res;

    file_desc = open(test_file, O_RDWR | O_CREAT, 0666);
    if (!file_desc) {
        fprintf(stderr, "Nemohu otevt %s pro ten/zpis\n", test_file);
        exit(EXIT_FAILURE);
    }
// Ve zbytku programu urme rzn oblasti souboru a vyzkoume na nich rzn operace uzamykn:
    region_to_lock.l_type = F_RDLCK;
    region_to_lock.l_whence = SEEK_SET;
    region_to_lock.l_start = 10;
    region_to_lock.l_len = 5;
    printf("Proces %d, pokus o F_RDLCK, oblast %d-%d\n", getpid(),
            (int)region_to_lock.l_start, (int)(region_to_lock.l_start +
            region_to_lock.l_len));
    res = fcntl(file_desc, F_SETLK, &region_to_lock);
    if (res == -1) {
        printf("Proces %d - nepodailo se uzamknout oblast\n", getpid());
    } else {
        printf("Proces %d - zskal zmek oblasti\n", getpid());
    }

    region_to_lock.l_type = F_UNLCK;
    region_to_lock.l_whence = SEEK_SET;
    region_to_lock.l_start = 10;
    region_to_lock.l_len = 5;
    printf("Proces %d, pokus o F_UNLCK, oblast %d-%d\n", getpid(),
            (int)region_to_lock.l_start,
            (int)(region_to_lock.l_start +
    region_to_lock.l_len));
    res = fcntl(file_desc, F_SETLK, &region_to_lock);
    if (res == -1) { 
        printf("Proces %d - nepodailo se odemknout oblast\n", getpid());
    } else {
        printf("Proces %d - odemknul oblast\n", getpid());
    }

    region_to_lock.l_type = F_UNLCK;
    region_to_lock.l_whence = SEEK_SET;
    region_to_lock.l_start = 0;
    region_to_lock.l_len = 50;
    printf("Proces %d, pokus o F_UNLCK, oblast %d-%d\n", getpid(),
            (int)region_to_lock.l_start,
            (int)(region_to_lock.l_start +
    region_to_lock.l_len));
    res = fcntl(file_desc, F_SETLK, &region_to_lock);
    if (res == -1) {
        printf("Proces %d - nepodailo se odemknout oblast\n", getpid());
    } else {
        printf("Proces %d - odemknul oblast\n", getpid());
    }

    region_to_lock.l_type = F_WRLCK;
    region_to_lock.l_whence = SEEK_SET;
    region_to_lock.l_start = 16;
    region_to_lock.l_len = 5;
    printf("Proces %d, pokus o F_WRLCK, oblast %d-%d\n", getpid(),
            (int)region_to_lock.l_start,
            (int)(region_to_lock.l_start +
    region_to_lock.l_len));
    res = fcntl(file_desc, F_SETLK, &region_to_lock);
    if (res == -1) {
        printf("Proces %d - nepodailo se uzamknout oblast\n", getpid());
    } else {
        printf("Proces %d - zskal zmek oblasti\n", getpid());
    }

    region_to_lock.l_type = F_RDLCK;
    region_to_lock.l_whence = SEEK_SET;
    region_to_lock.l_start = 40;
    region_to_lock.l_len = 10;
    printf("Proces %d, trying F_RDLCK, region %d to %d\n", getpid(),
            (int)region_to_lock.l_start,
            (int)(region_to_lock.l_start +
    region_to_lock.l_len));
    res = fcntl(file_desc, F_SETLK, &region_to_lock);
    if (res == -1) {
        printf("Proces %d - nepodailo se uzamknout oblast\n", getpid());
    } else {
        printf("Proces %d - zskal zmek oblasti\n", getpid());
    }

    region_to_lock.l_type = F_WRLCK;
    region_to_lock.l_whence = SEEK_SET;
    region_to_lock.l_start = 16;
    region_to_lock.l_len = 5;
    printf("Proces %d, pokus o F_WRLCK s eknm, oblast %d-%d\n", getpid(),
            (int)region_to_lock.l_start,
            (int)(region_to_lock.l_start +
    region_to_lock.l_len));
    res = fcntl(file_desc, F_SETLKW, &region_to_lock);
    if (res == -1) {
        printf("Proces %d - nepodailo se uzamknout oblast\n", getpid());
    } else {
        printf("Proces %d - zskal zmek oblasti\n", getpid());
    }

    printf("Proces %d kon\n", getpid());
    close(file_desc);
    exit(EXIT_SUCCESS);
}

