/*
	Funkce ouch reaguje na signl, pedan v parametru sig; bude vyvolna pi vskytu signlu. 
	Jejm kolem je vytisknout zprvu, a pot obnovit vchoz chovn pi oeten 
	signlu SIGINT (ten normln generujeme stiskem Ctrl+C).
*/

#include <signal.h>
#include <stdio.h>
#include <unistd.h>

void ouch(int sig)
{
    printf("OUCH! - dostal jsem signl %d\n", sig);
    (void) signal(SIGINT, SIG_DFL);
}

/*
	Hlavn funkce main vstupuje do zachycen signlu SIGINT, vygenerovanho pi stisku Ctrl+C. 
	Zbytek asu ji strv v nekonen smyce a opakovan kadou sekundu vypisuje zprvu.
*/
int main()
{
    (void) signal(SIGINT, ouch);

    while(1) {
        printf("Hello World!\n");
        sleep(1);
    }
}

