// Zaneme hlavikovmi soubory, jednou konstantou #define a kontrolou 
// zadn sprvnho potu parametr pkazovho dku:
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#define FIFO_NAME "/tmp/my_fifo"

int main(int argc, char *argv[])
{
    int res;
    int open_mode = 0;
    int i;

    if (argc < 2) {
        fprintf(stderr, "Voln: %s <njak kombinace\
                O_RDONLY O_WRONLY O_NONBLOCK>\n", *argv);
        exit(EXIT_FAILURE);
    }
// Jestlie test probhl sprvn, zvolme podle zadanch argument 
// hodnotu pznaku open_mode:
    for(i = 1; i <argc; i++) {
        if (strncmp(*++argv, "O_RDONLY", 8) == 0)
            open_mode |= O_RDONLY;
        if (strncmp(*argv, "O_WRONLY", 8) == 0)
            open_mode |= O_WRONLY;
        if (strncmp(*argv, "O_NONBLOCK", 10) == 0)
            open_mode |= O_NONBLOCK;
    }
// Dle zkontrolujeme, jestli existuje pslun soubor FIFO, a v ppad poteby jej 
// vytvome. Pot soubor FIFO oteveme a zapeme do nj jist vstup, zatmco 
// program se na chvli pozastav. Nakonec soubor FIFO uzaveme.
    if (access(FIFO_NAME, F_OK) == -1) {
        res = mkfifo(FIFO_NAME, 0777);
        if (res != 0) {
            fprintf(stderr, "Nemohu vytvoit soubor FIFO %s\n", FIFO_NAME);
            exit(EXIT_FAILURE);
        }
    }

    printf("Proces %d otevel FIFO\n", getpid());
    res = open(FIFO_NAME, open_mode);
    printf("Proces %d, vsledek %d\n", getpid(), res);
    sleep(5);
    if (res != -1) (void)close(res);
    printf("Proces %d skonil\n", getpid());
    exit(EXIT_SUCCESS);
}

