/* Nejprve zapeme "povinn" hlaviky #include: */
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <limits.h>
#include <sys/types.h>
#include <sys/stat.h>
/* Pot nadefinujeme pojmenovan roury; jedna roura bude slouit pro server, a pot 
 pro kadho klienta jedna. Klient me bt pitom i vce, a proto je soust 
 nzvu jeho roury jedinen ID procesu: */
#define SERVER_PIPE "/tmp/server_pipe"
#define CLIENT_PIPE "/tmp/client_%d_pipe"

#define ERR_TEXT_LEN 80
/* 
	Jednotliv pkazy implementujeme jako vtov typy, nikoli jako konstanty #define.
	Pi tomto een me kompiltor provdt psnj typov kontroly a zrove si tak 
	usnadnme ladn aplikace, protoe mnoh debuggery um zobrazit nzvy vtovch 
	konstant - u nzv definovanch v direktiv #define to ale mon nen.
	Prvn definice typedef popisuje typ poadavku odeslanho na server, druh 
	pak vyjaduje odpov zaslanou serverem ke klientu:
*/
typedef enum {
    s_create_new_database = 0,
    s_get_cdc_entry,
    s_get_cdt_entry,
    s_add_cdc_entry,
    s_add_cdt_entry,
    s_del_cdc_entry,
    s_del_cdt_entry,
    s_find_cdc_entry
} client_request_e;

typedef enum {
    r_success = 0,
    r_failure,
    r_find_no_more
} server_response_e;
/*
	Dle nadeklarujeme strukturu, kter bude tvoit zprvu pedvanou v obou 
	smrech mezi obma procesy.
	Protoe poloky cdc_entry a cdt_entry fakticky nikdy nepotebujeme vracet v 
	jedin odpovdi, mohli bychom je klidn nadefinovat ve struktue typu union. 
	Pro jednoduchost je nicmn ponechme oddlen, m si tak usnadnme 
	itelnost a pozdj drbu kdu.
*/
typedef struct {
    pid_t               client_pid;
    client_request_e    request;
    server_response_e   response;
    cdc_entry           cdc_entry_data;
    cdt_entry           cdt_entry_data;
    char                error_text[ERR_TEXT_LEN + 1];
} message_db_t;
/*
	Nakonec se dostvme k funkcm rozhran roury, kter provdj vlastn 
	penos dat a kter jsou implementovny v souboru pipe_imp.c. Ty je mon 
	rozdlit do dvou blok, a sice na serverov a klientsk funkce:
*/
int server_starting(void);
void server_ending(void);
int read_request_from_client(message_db_t *rec_ptr);
int start_resp_to_client(const message_db_t mess_to_send);
int send_resp_to_client(const message_db_t mess_to_send);
void end_resp_to_client(void);

int client_starting(void);
void client_ending(void);
int send_mess_to_server(message_db_t mess_to_send);
int start_resp_from_server(void);
int read_resp_from_server(message_db_t *rec_ptr);
void end_resp_from_server(void);

