#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

int main(int argc, char *argv[])
{
    char *host;
    int sockfd;
    int len, result;
    struct sockaddr_in address;
    struct hostent *hostinfo;
    struct servent *servinfo;
    char buffer[128];

    if(argc == 1)
        host = "localhost";
    else
        host = argv[1];
// Dle zjistme adresu hostitele a pokud ji nenajdeme, oznmme chybu:
    hostinfo = gethostbyname(host);
    if(!hostinfo) {
        fprintf(stderr, "hostitel neexistuje: %s\n", host);
        exit(1);
    }
// Zkontrolujeme, jestli je na tomto hostiteli sluba daytime k dispozici:
    servinfo = getservbyname("daytime", "tcp");
    if(!servinfo) {
        fprintf(stderr,"sluba daytime nen k dispozici\n");
        exit(1);
    }
    printf("port sluby daytime je %d\n", ntohs(servinfo -> s_port));
// Vytvome soket:
    sockfd = socket(AF_INET, SOCK_STREAM, 0);
// Nsledn zkonstruujeme adresu, kterou pedme do voln connect:
    address.sin_family = AF_INET;
    address.sin_port = servinfo -> s_port;
    address.sin_addr = *(struct in_addr *)*hostinfo -> h_addr_list;
    len = sizeof(address);
// Nakonec se pipojme a zjistme poadovan informace:
    result = connect(sockfd, (struct sockaddr *)&address, len);
    if(result == -1) {
        perror("oops: getdate");
        exit(1);
    }

    result = read(sockfd, buffer, sizeof(buffer));
    buffer[result] = '\0';
    printf("peteno %d bajt: %s", result, buffer);

    close(sockfd);
    exit(0);
}

