/*
	Do poslednho serverovho pkladu tto kapitoly, server5.c, zalenme namsto 
	souboru signal.h z posledn verze hlavikov soubory sys/time.h a sys/ioctl.h 
	a nadeklarujeme tak nkolik novch promnnch pro prci s volnm select:
*/
#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <netinet/in.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <stdlib.h>

int main()
{
    int server_sockfd, client_sockfd;
    int server_len, client_len;
    struct sockaddr_in server_address;
    struct sockaddr_in client_address;
    int result;
    fd_set readfds, testfds;
// Vytvome a pojmenujeme soket pro server:
    server_sockfd = socket(AF_INET, SOCK_STREAM, 0);

    server_address.sin_family = AF_INET;
    server_address.sin_addr.s_addr = htonl(INADDR_ANY);
    server_address.sin_port = htons(9734);
    server_len = sizeof(server_address);

    bind(server_sockfd, (struct sockaddr *)&server_address, server_len);
// Pot vytvome frontu spojen a inicializujeme mnoinu readfds, podle n 
// budeme obsluhovat vstup ze soketu server_sockfd:
    listen(server_sockfd, 5);

    FD_ZERO(&readfds);
    FD_SET(server_sockfd, &readfds);
/*
	Nyn zahjme ekn na klientsk poadavky. Protoe jsme do parametru timeout 
	pedali nulov ukazatel, nebude probhat dn asov limit. Jestlie funkce 
	select vrt hodnotu men ne 1, program skon a oznm chybu:
*/
    while(1) {
        char ch;
        int fd;
        int nread;

        testfds = readfds;

        printf("server ek\n");
        result = select(FD_SETSIZE, &testfds, (fd_set *)0,
                (fd_set *)0, (struct timeval *) 0);
        if(result < 1) {
            perror("server5");
            exit(1);
        }
// Jakmile se nm poda detekovat aktivitu, zjistme pomoc makra FD_ISSET, 
// nad kterm z deskriptor aktivita probh:
        for(fd = 0; fd < FD_SETSIZE; fd++) {
            if(FD_ISSET(fd,&testfds)) {
// Pokud se aktivita objevila nad soketem server_sockfd, mus to bt poadavek 
// na nov spojen, take pslun deskriptor client_sockfd pidme do mnoiny deskriptor:
                if(fd == server_sockfd) {
                    client_len = sizeof(client_address);
                    client_sockfd = accept(server_sockfd,
                            (struct sockaddr *)&client_address, &client_len);
                    FD_SET(client_sockfd, &readfds);
                    printf("pidvm klienta na fd %d\n", client_sockfd);
                }
/*
	Nejedn-li se o aktivitu serveru, mus to bt klient. Jestlie pijmeme zprvu close, 
	znamen to, e klient skonil a meme jej odebrat z mnoiny deskriptor. 
	Jinak klienta "obsloume" stejn jako v pedchozch pkladech.
*/
                else {
                    ioctl(fd, FIONREAD, &nread);

                    if(nread == 0) {
                        close(fd);
                        FD_CLR(fd, &readfds);
                        printf("odebrm klienta na fd %d\n", fd);
                    }
                    else {
                        read(fd, &ch, 1);
                        sleep(5);
                        printf("obsluhuji klienta na fd %d\n", fd);
                        ch++;
                        write(fd, &ch, 1);
                    }
                }
            }
        }
    }
}
