#include <gtk/gtk.h>
#include <stdio.h>

GtkWidget *togglebutton;
GtkWidget *checkbutton;
GtkWidget *radiobutton1, *radiobutton2;

void closeApp ( GtkWidget *window, gpointer data)
{
    gtk_main_quit();
}
/*
	Zde nadefinujeme pomocnou funkci, kter slou ovldac prvky GtkWidget a GtkLabel 
	do objektu GtkHbox, kter nsledn vlo do zadanho kontejnerovho objektu. Tm si 
	uetme zpis opakovanho kdu.
*/
void add_widget_with_label(GtkContainer * box, gchar * caption, GtkWidget * widget)
{
    GtkWidget *label = gtk_label_new (caption);
    GtkWidget *hbox = gtk_hbox_new (TRUE, 4);

    gtk_container_add(GTK_CONTAINER (hbox), label);
    gtk_container_add(GTK_CONTAINER (hbox), widget);

    gtk_container_add(box, hbox);
}
/*
	Dal pomocn funkce m nzev print_active a jejm kolem je textov vpis aktulnho 
	stavu danho tlatka GtkToggleButton. Vyvolvme ji z funkce button_clicked, kter 
	je zptnm volnm napojena na signl clicked tlatka OK.
*/
void print_active(char * button_name, GtkToggleButton *button)
{
    gboolean active = gtk_toggle_button_get_active(button);

    printf("%s is %s\n", button_name, active?"aktivn":"neaktivn");
}

void button_clicked(GtkWidget *button, gpointer data)
{
    print_active("Checkbutton", GTK_TOGGLE_BUTTON(checkbutton));
    print_active("Togglebutton", GTK_TOGGLE_BUTTON(togglebutton));
    print_active("Radiobutton1", GTK_TOGGLE_BUTTON(radiobutton1));
    print_active("Radiobutton2", GTK_TOGGLE_BUTTON(radiobutton2));
    printf("\n");
}
// Ve funkci main vytvome objekty tlatek, naskldme je do kontejneru GtkVBox 
// s textovmi popisy a napojme signl zptnho voln na tlatko OK:
gint main (gint argc, gchar *argv[])
{
    GtkWidget *window;
    GtkWidget *button;
    GtkWidget *vbox;

    gtk_init (&argc, &argv);
    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_window_set_default_size(GTK_WINDOW(window), 200, 200);
    g_signal_connect ( GTK_OBJECT (window), "destroy",
                       GTK_SIGNAL_FUNC (closeApp), NULL);

    button = gtk_button_new_with_label("OK");
    togglebutton = gtk_toggle_button_new_with_label("Pepnac");
    checkbutton = gtk_check_button_new();
    radiobutton1 = gtk_radio_button_new(NULL);
    radiobutton2 = gtk_radio_button_new_from_widget(GTK_RADIO_BUTTON(radiobutton1));

    vbox = gtk_vbox_new (TRUE, 4);
    add_widget_with_label (GTK_CONTAINER(vbox), "Pepnac tlatko:", togglebutton);
    add_widget_with_label (GTK_CONTAINER(vbox), "Zakrtvac polko:", checkbutton);
    add_widget_with_label (GTK_CONTAINER(vbox), "Radio 1:", radiobutton1);
    add_widget_with_label (GTK_CONTAINER(vbox), "Radio 2:", radiobutton2);
    add_widget_with_label (GTK_CONTAINER(vbox), "Tlatko:", button);

    g_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(button_clicked), NULL);

    gtk_container_add(GTK_CONTAINER(window), vbox);
    gtk_widget_show_all(window);
    gtk_main ();

    return 0;
}
